using System;
using Foxit.PDF;
using Foxit.PDF.Merger;
using Foxit.PDF.PageElements;

namespace Web_CSharp.MergerExamples
{
	public partial class SelectPages : System.Web.UI.Page
	{

		protected void Page_Load(object sender, System.EventArgs e)
		{
			if( IsPostBack )
			{
				// Create a document and set it's properties
				Document document = new Document();
				document.Creator = "SelectPages.aspx";
				document.Author = "Foxit Software";
				document.Title = "Select Pages";

				// Add a title page to the document
				AddTitlePage( document );

				// Add selected import pages to the document
				AddSelectedPages( document );

				// Outputs the document to the current web page
				document.DrawToWeb( "SelectPages.pdf" );
				Visible = false;
			}
		}

		private void AddTitlePage( Document document )
		{
			// Creates title page
			Page page = new Page( PageSize.Letter, PageOrientation.Portrait, 50 );
			// Creates and centeres image on title page
			Image image = new Image( MapPath( "../Images/FoxitLogo.png" ), page.Dimensions.Body.Width / 2, page.Dimensions.Body.Height / 2, 0.48f );
			image.Align = Align.Center;
			image.VAlign = VAlign.Center;
			// Adds text and image to title page
			page.Elements.Add( new TextArea( "Title Page", 0, 0, page.Dimensions.Body.Width, 72, Foxit.PDF.Font.Helvetica, 72, TextAlign.Center ) );
			page.Elements.Add( image );
			// Adds title page to document
			document.Pages.Add( page );
		}

		private void AddSelectedPages( Document document )
		{
			AddSelectedPagesFromDocument( document, chkDocumentA.Items, MapPath( "../PDFs/DocumentA.pdf" ) );
			AddSelectedPagesFromDocument( document, chkDocumentB.Items, MapPath( "../PDFs/DocumentB.pdf" ) );
			AddSelectedPagesFromDocument( document, chkDocumentC.Items, MapPath( "../PDFs/DocumentC.pdf" ) );
			AddSelectedPagesFromDocument( document, chkDocumentD.Items, MapPath( "../PDFs/DocumentD.pdf" ) );
		}

		private void AddSelectedPagesFromDocument( Document document, System.Web.UI.WebControls.ListItemCollection items, string importDocument )
		{
			PdfDocument pdfDocument = new PdfDocument( importDocument );
			foreach( System.Web.UI.WebControls.ListItem item in items )
			{
				// Iterate the Checkbox collection
				if( item.Selected )
				{
					// Add selected page to the document
					document.Pages.Add( new ImportedPage( pdfDocument.GetPage( int.Parse( item.Value ) ) ) );
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
		}
		#endregion
	}
}
